//////////////////
// This class mimics a CFile, but writes ASCII instead of binary. The only
// really important functions are Read and Write. The rest are there as a
// safety-measure to make sure MFC isn't calling them.
//
class CAsciiFile : public CFile {
public:
   CAsciiFile();
   virtual ~CAsciiFile();

// Overrides from CFile
   virtual UINT   Read(void FAR* lpBuf, UINT nCount);
   virtual void   Write(const void FAR* lpBuf, UINT nCount);

   virtual DWORD  GetPosition() const;
   virtual LONG   Seek(LONG lOff, UINT nFrom);
   virtual CFile* Duplicate() const;
   virtual void   SetLength(DWORD dwNewLen);
   virtual DWORD  GetLength() const;
   virtual void   LockRange(DWORD dwPos, DWORD dwCount);
   virtual void   UnlockRange(DWORD dwPos, DWORD dwCount);

// Functions inherited from CFile
// virtual BOOL   Open(CSTR filename, DWORD mode, CFileException* pErr=NULL);
// virtual void   Abort();
// virtual void   Flush();
// virtual void   Close();
};
