// atest.cpp : Implementation of application class.
//

#include "stdafx.h"
#include "atest.h"
#include "doc.h"

CTestApp NEAR theApp;      // the one and only app object

//////////////////
// InitInstance just exercises the document save/load functions and
// quits the app by returnrning FALSE. No windows are ever created.
//
BOOL CTestApp::InitInstance()
{
   // Create a doc and set its members
   CMyDoc *pdoc1 = new CMyDoc;
   pdoc1->m_string = "Hello, world";
   pdoc1->m_number = 17;
   const char* pszFileName = "FOO.DOC";

   // Save it, then destroy it
   TRACE0("Before saving, document is: ");
   pdoc1->Dump(afxDump);
   TRACE1("\nSaving %s...\n", pszFileName);
   pdoc1->OnSaveDocument(pszFileName);       // Save it

   // Create a new doc and load it from the file I just saved
   // Should come out the same.
   CMyDoc* pdoc2 = new CMyDoc;
   TRACE0("Created new document, ");
   pdoc2->Dump(afxDump);
   TRACE1("\n\nLoading %s...\n", pszFileName);
   pdoc2->OnOpenDocument(pszFileName);       // Load it

   // Check that documents are the same
   TRACE0("After loading, document is: ");
   pdoc2->Dump(afxDump);
   if (pdoc1->m_number==pdoc2->m_number &&
       pdoc2->m_string ==pdoc2->m_string) {
      TRACE0("\nTHE SAME!\n");
   } else {
      TRACE0("Something's rotten in Denmark\n");
   }

   delete pdoc1;           // clean  up
   delete pdoc2;           // ...

   return FALSE;           // terminate app
}
