#include "stdafx.h"
#include "doc.h"
#include "afile.h"

IMPLEMENT_DYNCREATE(CMyDoc, CDocument);

CMyDoc::CMyDoc() : m_number(0)
{
}

CMyDoc::~CMyDoc()
{
}

////////////////
// This function is copied verbatim from the MFC source, after which
// only  one line has been changed (see below).
//
BOOL CMyDoc::OnOpenDocument(const char* pszPathName)
{
   if (IsModified())
      TRACE0("Warning: OnOpenDocument replaces an unsaved document\n");

   CAsciiFile file;        // <**** This is the only line different from MFC 
   CFileException fe;
   if (!file.Open(pszPathName, CFile::modeRead | CFile::shareDenyWrite, &fe))
   {
      ReportSaveLoadException(pszPathName, &fe,
         FALSE, AFX_IDP_FAILED_TO_OPEN_DOC);
      return FALSE;
   }

   DeleteContents();
   SetModifiedFlag(TRUE);  // dirty during de-serialize

   CArchive loadArchive(&file, CArchive::load | CArchive::bNoFlushOnDelete);
   loadArchive.m_pDocument = this;
   loadArchive.m_bForceFlat = FALSE;
   TRY
   {
      BeginWaitCursor();
      Serialize(loadArchive);     // load me
      loadArchive.Close();
      file.Close();
   }
   CATCH_ALL(e)
   {
      file.Abort(); // will not throw an exception
      DeleteContents();   // remove failed contents
      EndWaitCursor();

      TRY
         ReportSaveLoadException(pszPathName, e,
            FALSE, AFX_IDP_FAILED_TO_OPEN_DOC);
      END_TRY
      return FALSE;
   }
   END_CATCH_ALL

   EndWaitCursor();
   SetModifiedFlag(FALSE);     // start off with unmodified
   return TRUE;
}

////////////////
// Likwise here too. Only one line different from MFC.
//
BOOL CMyDoc::OnSaveDocument(const char* pszPathName)
{
   CAsciiFile file;        // <**** this is the only line different from MFC
   CFileException fe;

   if (!file.Open(pszPathName, CFile::modeCreate |
     CFile::modeReadWrite | CFile::shareExclusive, &fe))
   {
      ReportSaveLoadException(pszPathName, &fe,
         TRUE, AFX_IDP_INVALID_FILENAME);
      return FALSE;
   }

   CArchive saveArchive(&file, CArchive::store | CArchive::bNoFlushOnDelete);
   saveArchive.m_pDocument = this;
   saveArchive.m_bForceFlat = FALSE;
   TRY
   {
      BeginWaitCursor();
      Serialize(saveArchive);     // save me
      saveArchive.Close();
      file.Close();
   }
   CATCH_ALL(e)
   {
      file.Abort(); // will not throw an exception
      EndWaitCursor();

      TRY
         ReportSaveLoadException(pszPathName, e,
            TRUE, AFX_IDP_FAILED_TO_SAVE_DOC);
      END_TRY
      return FALSE;
   }
   END_CATCH_ALL

   EndWaitCursor();
   SetModifiedFlag(FALSE);     // back to unmodified

   return TRUE;        // success
}

//////////////////
// Typical document serialization function. 
//
void CMyDoc::Serialize(CArchive& ar)
{
   if (ar.IsStoring()) {
      ar << m_string;
      ar << m_number;
   } else {
      ar >> m_string;
      ar >> m_number;
   }
}

//////////////////
// Used to show the document in the debug window
//
void CMyDoc::Dump(CDumpContext& dc) const
{
   CObject::Dump(dc);
   AFX_DUMP1(dc, "\nm_string= ", m_string);
   AFX_DUMP1(dc, "\nm_number= ", m_number);
}
